# Univerxel <!-- omit in toc -->

Work in progress galaxy down to atom (mostly centimeter) online voxel game

## Table of Contents <!-- omit in toc -->

- [About The Project](#about-the-project)
  - [Built With](#built-with)
- [Getting Started](#getting-started)
  - [Prerequisites](#prerequisites)
    - [Build](#build)
    - [Optionally](#optionally)
  - [Installation](#installation)
- [Usage](#usage)
- [RoadMap](#roadmap)
- [License](#license)
- [Contact](#contact)


<!-- ABOUT THE PROJECT -->
## About The Project

Experimental project using OpenGL and Vulkan.


### Built With

* C++
* OpenGL
* Vulkan
* ImGui
* ENet
* FasNoiseSIMD
* Love and insomnia


<!-- GETTING STARTED -->
## Getting Started

To get a local copy up and running, follow these simple steps.


### Prerequisites

* OpenGL or Vulkan driver

#### Build

* C++17
* CMake 3.11
* System window headers *(xorg-dev)*

#### Optionally

* Python: utility scripts
* Tracy v0.7: profiling
* glslc: compile vk shaders

### Installation

1. Clone the project repo
```sh
git lfs clone --recursive https://git.wadza.fr/me/univerxel.git
```
2. Create build folder and move
```sh
mkdir build && cd build
```
3. Build CMake
```sh
cmake ..
```
4. Build Make
```sh
make
```


<!-- USAGE EXAMPLES -->
## Usage

```sh
./univerxel
```

Profit !



<!-- ROADMAP -->
## RoadMap

See [Features](TODO.md)

<!-- LICENSE -->
## License

Distributed under the MIT License. See [LICENSE](LICENSE) for more information.



<!-- CONTACT -->
## Contact

Maelys Bois - [/me](https://git.wadza.fr/me) - me@wadza.fr

Project Link: [https://git.wadza.fr/me/univerxel](https://git.wadza.fr/me/univerxel)
