#include "WorldProgram.hpp"

#include "../Renderer.hpp"

using namespace pass;

WorldProgram::WorldProgram(const WorldProgram::options& opts): VoxelProgram(opts) {

    ModelMatrixID = glGetUniformLocation(ProgramID, "Model");
}

WorldProgram::~WorldProgram() { }

buffer::params WorldProgram::setup(render::gl::Renderer *renderer, glm::mat4 modelMatrix) {
    setModel(&modelMatrix[0][0]);
    return VoxelProgram::setup(renderer);
}

void WorldProgram::setModel(const GLfloat *matrix) {
    glUniformMatrix4fv(ModelMatrixID, 1, GL_FALSE, matrix);
}
