#pragma once

#include "forward.hpp"

namespace render::vk {

class Pipeline {
public:
    Pipeline(VkDevice, const PhysicalDeviceInfo&, const renderOptions&);
    ~Pipeline();

    PipelineRef getRef() { return std::make_pair(renderPass, graphicsPipeline); }

private:
    VkDevice device;

    VkShaderModule vsShader;
    VkShaderModule fsShader;

    VkRenderPass renderPass;
    VkPipelineLayout pipelineLayout;
    VkPipeline graphicsPipeline;
};

}