#pragma once

#include "config.hpp"

namespace state {

/// Live state
struct state {
    bool capture_mouse = true;
    camera_pos position = camera_pos(voxel_pos(0), 1);
    std::optional<world::Universe::ray_target> look_at = {};

    std::shared_ptr<contouring::Abstract> contouring;

    std::array<char, 256> console_buffer;
};

/// Readonly metrics
struct reports {
    size_t tris_count = 0;
    size_t models_count = 0;
};

}