#pragma once

#include "Universe.hpp"
#include "../../core/server_handle.hpp"

namespace world::client {
    /// Whole universe container in client with in-memory server
    class LocalUniverse final: public Universe {
    public:
        LocalUniverse(server_handle *const handle);
        ~LocalUniverse();

        void update(voxel_pos pos, float deltaTime) override;
        void emit(const action::packet &) override;

        void setContouring(const std::shared_ptr<contouring::Abstract> &ct) override;

        ray_result raycast(const geometry::Ray &ray) const override;

    protected:
        server_handle *const handle;

        chunk_pos last_chunk = chunk_pos(INT_MAX);
    };
}