#pragma once

#include "../../core/world/Universe.hpp"
#include "../../core/world/actions.hpp"
#include "../../core/net/data.hpp"
#include <memory>

namespace contouring {
    class Abstract;
}
namespace world::client {
    /// Whole universe container in abstract client
    class Universe: public world::Universe {
    public:
        Universe();
        virtual ~Universe();

        struct connection: net::connection {
            connection(): net::connection{"localhost", 4242} { }
        };

        /// Update edits and contouring
        virtual void update(voxel_pos pos, float deltaTime) = 0;

        /// Send action to ServerUniverse
        virtual void emit(const action::packet &) = 0;

        /// Change contouring worker
        virtual void setContouring(const std::shared_ptr<contouring::Abstract> &ct);
        /// Get current contouring worker
        std::shared_ptr<contouring::Abstract> getContouring() const {
            return contouring;
        }

        //TODO: move to ClientUniverse
        //void getEntitiesModels(const std::function<void(const std::vector<glm::mat4> &, buffer::Abstract *const)> &draw, const std::optional<geometry::Frustum> &frustum, const glm::llvec3 &offset, int density);

    protected:
        /// Contouring worker
        std::shared_ptr<contouring::Abstract> contouring;
    };
}