#pragma once

#include <fstream>
#include <vector>
#include "../utils/logger.hpp"

namespace data {

class file_content: public std::vector<char> {
public:
    // Read first
    file_content(const std::vector<std::string>& paths): std::vector<char>() {
        std::ifstream is = [&]() {
            for(auto& path: paths) {
                std::ifstream is(path, std::ios::in | std::ios::binary | std::ios::ate);
                if(is.good()) {
                    return is;
                }
                is.close();
            }
            FATAL("File not found " << paths.back());
        }();
        const auto end = is.tellg();
        is.seekg(0, std::ios::beg);
        resize(end - is.tellg());
        is.read(data(), size());
        is.close();
    }
};

}